Jump to content

Renommer présentation


Recommended Posts

Salut

 

Quelque chose dans ce style

 

(defun c:ron(/ doc express lay lst n i txt)
 (setq doc (vla-get-activedocument (vlax-get-acad-object))
n -1
i 1
 )
 (vla-startundomark doc)
 (if (eval 'acet-ui-progress-done)
   (progn
     (acet-ui-progress-init "" (1- (vla-get-count (vla-get-layouts doc))))
     (setq express T)
   )
   (progn
     (princ "\nTravail en cours...")
     (princ)
   )
 )
 (vlax-for lay (vla-get-layouts doc)
   (setq lst (cons (list (vla-get-taborder lay) lay) lst))
 )
 (while (setq lay (assoc i lst))
   (if (eq n -1)
     (setq txt "Cart")
     (setq txt (itoa n))
   )
   (while (< (strlen txt) 2)
     (setq txt (strcat "0" txt))
   )
   (if (vl-catch-all-error-p (vl-catch-all-apply 'vla-put-name (list (cadr lay) txt)))
     (progn
(vla-put-name (vla-item (vla-get-layouts doc) txt) (strcat "Temporaire_Patrick_35___" txt))
(vla-put-name (cadr lay) txt)
     )
   )
   (and express (acet-ui-progress-safe i))
   (setq n (1+ n)
  i (1+ i)
   )
 )
 (and express (acet-ui-progress-done))
 (princ (strcat "\nRenumérotation de " (itoa (1+ n)) " présentation(s)."))
 (vla-endundomark doc)
 (princ)
)

 

@+

 

[Edité le 23/2/2009 par Patrick_35]

Les Lisps de Patrick

Le but n'est pas toujours placé pour être atteint, mais pour servir de point de mire.

Joseph Joubert, 1754-1824

Link to post
Share on other sites

Bon code patrick, comme toujours ;) .

 

mais il génère quand même une erreur => si la présentation XX existe déjà ca plante:

; erreur: Erreur Automation La présentation existe déjà

 

Ma journée est finie (le vendredi j'arrête plus tôt) et cet aprem je dois vadrouiller,

donc je laisse le producteur corriger son code.

 

Allez bon week-end à tous :cool:

Tous pour lisp, Lisp pour tous!

Avec Revit, cela ne vas trop vite...

Link to post
Share on other sites

Salut

 

Bon code patrick, comme toujours ;) .

Merci :)

 

mais il génère quand même une erreur => si la présentation XX existe déjà ca plante:

; erreur: Erreur Automation La présentation existe déjà

Bien vu, c'est corrigé

 

Ma journée est finie (le vendredi j'arrête plus tôt) et cet aprem je dois vadrouiller,

donc je laisse le producteur corriger son code.

 

Allez bon week-end à tous :cool:

Bon week-end et bonne balade.

 

@+

Les Lisps de Patrick

Le but n'est pas toujours placé pour être atteint, mais pour servir de point de mire.

Joseph Joubert, 1754-1824

Link to post
Share on other sites

Salut Patrick

 

Merci du temps de que me consacre.

 

Le nouveau lisp que tu as écris ne touche pas au 2 première présentations. Hors je voudrais savoir si il est possible qu il fasse automatiquement les 2 présentations nommées respectivement Cart puis 00. Ensuite il reprend en 01;02;03;04;05 ect

 

Merci pour tout

 

Ciao

 

Link to post
Share on other sites
  • 8 years later...

Bonjour Patrick,

Mes présentations s’appellent par exemple 1, 2, 3, ...

Lorsque j'ajoute une présentation au milieu, il faut que je renomme celles qui la suivent. Existe t il un lisp pour cela ?

 

Exemple : si j'ajoute une présentation entre la 21 et la 22, je voudrais qu'à partir de la 22, le numéro des présentations s'incrémentent de 1 de plus (22+1, 23+1, 24+1 ...)

 

Merci d'avance

Coco.

Link to post
Share on other sites

Salut

 

Quelque chose dans ce style

 

(defun c:ron(/ doc express lay lst n i txt)
 (setq doc (vla-get-activedocument (vlax-get-acad-object))
n -1
i 1
 )
 (vla-startundomark doc)
 (if (eval 'acet-ui-progress-done)
   (progn
     (acet-ui-progress-init "" (1- (vla-get-count (vla-get-layouts doc))))
     (setq express T)
   )
   (progn
     (princ "\nTravail en cours...")
     (princ)
   )
 )
 (vlax-for lay (vla-get-layouts doc)
   (setq lst (cons (list (vla-get-taborder lay) lay) lst))
 )
 (while (setq lay (assoc i lst))
   (if (eq n -1)
     (setq txt "Cart")
     (setq txt (itoa n))
   )
   (while (< (strlen txt) 2)
     (setq txt (strcat "0" txt))
   )
   (if (vl-catch-all-error-p (vl-catch-all-apply 'vla-put-name (list (cadr lay) txt)))
     (progn
(vla-put-name (vla-item (vla-get-layouts doc) txt) (strcat "Temporaire_Patrick_35___" txt))
(vla-put-name (cadr lay) txt)
     )
   )
   (and express (acet-ui-progress-safe i))
   (setq n (1+ n)
 	i (1+ i)
   )
 )
 (and express (acet-ui-progress-done))
 (princ (strcat "\nRenumérotation de " (itoa (1+ n)) " présentation(s)."))
 (vla-endundomark doc)
 (princ)
)

 

@+

 

[Edité le 23/2/2009 par Patrick_35]

 

Bonjour Patrick,

J'ai eu une petite idée pour mon problème. Juste est ce qu'il est possible que cette numérotation commence à partir de la présentation que l'on veut ?

Puisque je voudrais les numéros 01, 02, 03 ... mais pas du début, je souhaiterais choisir la présentation où commencerait cette incrémentation. Ensuite si cela fonctionne j'utiliserait le lisp Tabsort de Giles pour ajouter un préfixe devant ces numéros et tout serait parfait.

Merci d'avance

 

Merci d'avance

Coco.

Link to post
Share on other sites

Join the conversation

You can post now and register later. If you have an account, sign in now to post with your account.

Guest
Reply to this topic...

×   Pasted as rich text.   Paste as plain text instead

  Only 75 emoji are allowed.

×   Your link has been automatically embedded.   Display as a link instead

×   Your previous content has been restored.   Clear editor

×   You cannot paste images directly. Upload or insert images from URL.

Loading...
×
×
  • Create New...